Attribute VB_Name = "vbzMenue"
' Modulname : vbzMenue.bas
' Version   : 0.9
' Stand     : 11.09.2004
' Quelle    : http://www.vb-zentrum.de

Option Explicit

Private Declare Function GetMenu Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetSubMenu Lib "user32" (ByVal _
        hMenu As Long, ByVal nPos As Long) As Long
Private Declare Function GetSystemMenu Lib "user32" (ByVal _
        hwnd As Long, ByVal bRevert As Long) As Long
Private Declare Function GetMenuItemCount Lib "user32" (ByVal hMenu As Long) As Long
Private Declare Function AppendMenu Lib "user32" Alias "AppendMenuA" _
        (ByVal hMenu As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, _
        ByVal lpNewItem As String) As Long
Private Declare Function RemoveMenu Lib "user32" (ByVal hMenu As Long, _
        ByVal nPosition As Long, ByVal wFlags As Long) As Long
Private Declare Function DrawMenuBar Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function SetMenuItemBitmaps Lib "user32" (ByVal hMenu As Long, _
        ByVal nPosition As Long, ByVal wFlags As Long, ByVal hBitmapUnchecked As _
        Long, ByVal hBitmapChecked As Long) As Long

Private Const MF_STRING = &H0&
Private Const MF_BYCOMMAND = &H0&
Private Const MF_BYPOSITION = &H400&
Private Const MF_SEPARATOR = &H800&
Private Const MF_REMOVE = &H1000&

' Gibt einen String ohne '&' Hotkey-Zeichen zurck:
Public Function menu_string(s As String) As String
  menu_string = Replace(s, "&", "", 1, -1, vbTextCompare)
End Function

' Fgt einem Meneintrag ein Bild (Picture) hinzu
' Das Bild sollte 13x13 Pixel gro sein, die Transparentfarbe ist weiss!
' titel = Index des Mentitels (0-n)
' item  = Index des Menpunkts unter dem Mentitel (0-n)
' pic   = Das Bild bergibt man am Besten mit einem Imagelist-Objekt
'         z.B.: ImageList1.ListImages.item(4).Picture
Public Sub setMenuItemBmp(frm As Form, title As Integer, item As Integer, pic As Picture)
  Dim hMenu As Long
  
  hMenu = GetMenu(frm.hwnd)
  hMenu = GetSubMenu(hMenu, title)
  SetMenuItemBitmaps hMenu, item, MF_BYPOSITION, pic, pic
End Sub

' Versteckt das Systemmen einer Form
' Dadurch kann die Form nicht mehr durch Klicken auf 'X' geschlossen werden.
Public Sub hide_sysMenu(frm As Form)
  Dim hMenu As Long, mnuItem As Long
    
  hMenu = GetSystemMenu(frm.hwnd, 0)
  If hMenu <> 0 Then
    mnuItem = GetMenuItemCount(hMenu)
    If mnuItem <> 0 Then
      ' API-Funktionen durchfhren:
      RemoveMenu hMenu, mnuItem - 1, MF_BYPOSITION Or MF_REMOVE
      RemoveMenu hMenu, mnuItem - 2, MF_BYPOSITION Or MF_REMOVE
      DrawMenuBar frm.hwnd
    End If
  End If
End Sub
